
#include <Servo.h> //Biblioteka odpowiedzialna za serwa
#define GL 8
#define D1 5 
#define D2 6
#define CZ_G A0
#define CZ_D A1

Servo serwomechanizm;  //Tworzymy obiekt, dzięki któremu możemy odwołać się do serwa
int glowa_pozycja = 0; // określa pozycję gówy
int pwm_d1; // jasność świecenia diody D1
int pwm_d2; // jasność świecenia diody D2
int ton;  // częstotliwość tonu generowanego przez głośniczek
int glowa_norm = 90; // położenie głowy robota w stanie czuwania
int pwm_norm = 10;   // jasność LED w stanie czuwania UWAGA: należy dobrać w zalezności od zastosowanych
                     // diod LED i w zależności od własnych preferencji
int dzien_noc = 800; // jeżeli wartość odczytu z czujników będzie powyżej wskazane wartości
                    //- robot zinterprtuje to jako dzień, w przeciwnym przypadku - noc
int czas_dzien_noc = 10000; //jeśli zmiana natężenie światła będzie trwała dłużej niż 10 sekund
                            //robt zinterpretuje to jako zmianę noc/dzień lub dzień/noc
int swiatlo_gora;
int swiatlo_dol;
unsigned long czas_1;
boolean dzien;   // prawda jeśli dzień, fałsz jeśli noc
void setup() 
{ 
  serwomechanizm.attach(11);  //Serwomechanizm podłączony do pinu 11
  pinMode(D1,OUTPUT);
  pinMode(D2,OUTPUT);
} 
 void loop() 
{
    pobudka();
    czas_1 = 0; 
    while(dzien)
    {
       swiatlo_gora = analogRead(CZ_G);
       swiatlo_dol = analogRead(CZ_D);
       if ((swiatlo_gora > dzien_noc) and (swiatlo_dol > dzien_noc))
       {
         if (czas_1 == 0) czas_1 = millis();
         if ((millis() - czas_1) > czas_dzien_noc) dzien = false;
       }
       else czas_1 = 0;
    }
    zasypia();
    czas_1 = 0;
    while(not(dzien))
    {
       swiatlo_gora = analogRead(CZ_G);
       swiatlo_dol = analogRead(CZ_D);
       if ((swiatlo_gora < dzien_noc) and (swiatlo_dol < dzien_noc))
       {
         if (czas_1 == 0) czas_1 = millis();
         if ((millis() - czas_1) > czas_dzien_noc) dzien = true;
       }
       else czas_1 = 0;
    }
    pobudka();

}

void pobudka()
{
    for(glowa_pozycja = 0; glowa_pozycja <=glowa_norm; glowa_pozycja=glowa_pozycja+5)
  {
    pwm_d1 = map(glowa_pozycja, 0, glowa_norm, 0, pwm_norm);
    pwm_d2 = pwm_d1;
    ton = map(glowa_pozycja, 0, glowa_norm, 100, 1200); // częstotliwość dźwieku będzie stopniowo rosła
    serwomechanizm.write(glowa_pozycja); //głowa będzie się unosiła stopniowo
    analogWrite(D1, pwm_d1); // diody będą się stopniowo rozjaśniać
    analogWrite(D2, pwm_d2);
    tone(GL, ton);
    delay(50);
  }
  noTone(GL); 
}

void zasypia()
{
  for(glowa_pozycja = glowa_norm; glowa_pozycja >=0; glowa_pozycja=glowa_pozycja-10)
  {
    pwm_d1 = map(glowa_pozycja, 0, glowa_norm, 0, pwm_norm);
    pwm_d2 = pwm_d1;
    serwomechanizm.write(glowa_pozycja); //głowa będzie stopniowo opadała 
    analogWrite(D1, pwm_d1); // diody będą się stopniowo wygaszać
    analogWrite(D2, pwm_d2);
      //sekwencja generowanych dźwieków
      tone(GL, 100);
      delay(200);
      noTone(GL);
      delay(200);
      tone(GL, 80);
      delay(200);
      noTone(GL);
      delay(200);
      tone(GL, 60);
      delay(200);
      noTone(GL);
      delay(200);
      tone(GL, 40);
      delay(200);
      noTone(GL);
    }
}

void reakcja_1()
{
  for(ton=300; ton<=1300; ton=ton+10)
  {
    tone(GL, ton);
    pwm_d1 = map(ton, 300,1300,pwm_norm,255);
    pwm_d2 = pwm_d1;
    delay(10);
  }
  
}
