
#include <Servo.h> //Biblioteka odpowiedzialna za serwa
#define GL 8       // Głosniczek podłączony do pinu 9
#define D1 5       // Dioda LED podłączona do pinu 5
#define D2 6       // Dioda LED podłączona do pinu 6
#define CZ_G A0    // Czujnik górny podłączony do pinu A0
#define CZ_D A1    // Czujnik dolny podłączony do pinu A1


Servo serwomechanizm;  //Tworzy obiekt, dzięki któremu można odwołać się do serwa
int glowa_pozycja = 0; // określa pozycję głowy
int pwm_d1;            // jasność świecenia diody D1 (pwm)
int pwm_d2;            // jasność świecenia diody D2 (pwm)
int ton;               // częstotliwość tonu generowanego przez głośniczek
int glowa_norm = 60;   // położenie głowy robota w stanie czuwania
int pwm_norm = 10;     // jasność LED w stanie czuwania UWAGA: należy dobrać w zalezności od zastosowanych
                       // diod LED i w zależności od własnych preferencji
int dzien_noc = 800;   // jeżeli wartość odczytu z czujników będzie powyżej wskazane wartości
                       //- robot zinterprtuje to jako dzień, w przeciwnym przypadku - noc
int czas_dzien_noc = 10000; // jeśli zmiana natężenie światła będzie trwała dłużej niż 10 sekund
                            // robt zinterpretuje to jako zmianę dzień/noc
int czas_noc_dzien = 1000;  // jeśli zmiana natężenie światła będzie trwała dłużej niż 1 sekundę
                            // robt zinterpretuje to jako zmianę noc/dzień
int swiatlo_gora;           // natężenie śwaitłą padającego na górny czujnik
                            // - małe wartości to duże natężenie śwaitła, duże wartości - małe natężenie światła
int swiatlo_dol;            // natężenie śwaitłą padającego na dolny czujnik
                            // - małe wartości to duże natężenie śwaitła, duże wartości - małe natężenie światła
int swiatlo_gora_tlo;   // stałe natężenie śwaitła zewnętrznego - czujnik góra
int swiatlo_dol_tlo;    // stałe natężenie śwaitła zewnętrznego - czujnik dół
int dczas_0 = 10000;    // wartośc tej zmiennej okresla czas pomiedzy kolejnym sprawdzaniem natężenia śwaitła otoczenia
                        // w celu określenia wartości swiatła tła
int dczas_1 = 15000;    // maksymalny czas, w którym brak wykrycia zmiany natężenia śwaitła spowoduje reakcję robota (15 sekund)
int dczas_2 = 5000;     // maksymlny czas, w którym nastepujące po sobie zmiany natężenia śwaitła (czujnik górny)
                        // zostaną zinterpretowane jako występujące bezpośrednio po sobie
int dswiatlo = 100;     // różnica pomiędzy natężeniem śwaitła otoczenia (śwaitłem tła), a zarejestrowanym
                        // w danym momencie natężeniem natężeniem światła - np. gdy zsotanie na chwilę przysłoniety
int ile_zas    ;        // zmienna rejestrująca ilość przysłonięć czujnika
unsigned long czas_0;   // w zmiennej zapamietany zostanie aktualny czas, od którego rozpicznie się odmierzanie czasu
                        // pomiędzy kolejnym sprawdzaniem natężenia światła otoczenia - światła tła 
unsigned long czas_1;   // w zmiennej zapamietany zostanie aktualny czas, w którym obydwa czujniki zarejestrowały
                        // spadek natężenia śwaitła poniżej progu dzień/noc
unsigned long czas_3;   // w zmiennej zapamietany zostanie aktualny czas, w którym górny czujnik zarejestrował
                        // zmniejszenie natężenia śwaitła
unsigned long czas_4;   // w zmiennej zapamietany zostanie aktualny czas, w który wystąpiła ostatnia reakcja robota
boolean dzien;   // prawda jeśli dzień, fałsz jeśli noc

void setup() 
{ 
  serwomechanizm.attach(11);  // Serwomechanizm podłączony do pinu 11
  delay(2000);                // czas na ustabilizowanie się położenia serwa
  pinMode(D1,OUTPUT);     // zdefiniowanie pinu D1 jako wyjście
  pinMode(D2,OUTPUT);     // zdefiniowanie pinu D2 jako wyjście
  swiatlo_otoczenia();    // pomiar śwaitła otoczenia
  ile_zas = 0;            // wyzerowanie zmiennej
  dzien = true;            // ustawienie poczatkowe zmiennej
} 

void loop() 
{
// wykonanie procedury pobudka i ustawnienie wartości zmiennych
    pobudka(); 
    czas_1 = 0;
    czas_4 = millis();
    czas_0 = millis();
// pętla realizowana, gdy natężenie śwaitła odpowiada dniowi
    while(dzien)
    {
       swiatlo_gora = analogRead(CZ_G);  // zarejestrowanie aktualnego natężenia światła - czujnik górny
       swiatlo_dol = analogRead(CZ_D);   // zarejestrowanie aktualnego natężenia światła - czujnik dolny
       if((millis() - czas_0) > dczas_0) // jeśli minął czas określony w dczas_0 to nastąpi odczytanie natężenia tła
       {
          swiatlo_otoczenia();
          czas_0 = millis();
       }       
       if ((swiatlo_gora > dzien_noc) and (swiatlo_dol > dzien_noc)) // jeśli natężenie śwaitła zarejestrowane
                                                                     // przez oba czujniki będzie poza progiem dzień/noc
                                                                     // nastąpi rozpoczecie odliczania czasu trwania
                                                                     // spadku natężenia śwaitła
       {
         if (czas_1 == 0) czas_1 = millis();
         if ((millis() - czas_1) > czas_dzien_noc) dzien = false;    // jeśli niskie natężenie śwaitła utrzyma się
                                                                     // dłużej niż czas określony w zmiennej czas_dzien_noc
                                                                     // nastapi zinterpretowanie tego faktu jako noc
       }
       else czas_1 = 0;                   // jeśli natężenie śwaitła zarejestrowanego przez oba czujniki nie będzie poza
                                          // progiem dzień/noc - nastapi wyzerowanie zmiennej czas_1
       if ((swiatlo_gora - swiatlo_gora_tlo > dswiatlo) and (swiatlo_dol - swiatlo_gora < dswiatlo))
       // jeżeli stwierdzone zostanie przysłonięcie tylko czujnika górnego
       {
         if(ile_zas == 0) czas_3 = millis(); // jeżeli wcześniej czujnik nie został przysłoniety, czas przysłonięcia zostanie zapamiętany
         if(millis()-czas_3 < dczas_2) ile_zas++; // jeżeli kolejne przysłonięcia czujnika wystąpią bezpośrednio po sobie,
                                                             // w czasie określonym w zmiennej dczas_2, to nastąpi inkrementacja zmiennej
                                                             // liczącej ilość przysłonęć czujnika
         else ile_zas = 0;                                   // w przeciwnym przypadku nastąpi wyzerowanie tej zmiennej
         switch (ile_zas)     // wybór reakcji robota w zależności od kolejnych przysłonięć czujnika
         {
          case 1:
            reakcja_1();
            break;
          case 2:
            reakcja_2();
            break;
          default:
            reakcja_3();
            break;
         }
         czas_4 = millis();  // zapamiętanie czasu, w którym nastąpiła reakcja robota
       }
        if ((swiatlo_dol - swiatlo_dol_tlo > dswiatlo) and (swiatlo_gora - swiatlo_gora_tlo < dswiatlo))
        // jeżeli stwierdzone zostanie przysłonięcie tylko czujnika dolnego
        {
          reakcja_4();
          czas_4 = millis();
        }
        if (millis() - czas_4 > dczas_1) // jeżeli minął czas określony w zmiennej dczas_1 i żaden czujnik nie został przysłonięty
        {
          czas_4 = millis();
          reakcja_5();
        }
     }
 // wykonanie procedury zasypianie i ustawienie zmiennej czas_1
    zasypia();
    czas_1 = 0;
// pętla realizowana, gdy natężenie śwaitła odpowiada nocy
    while(not(dzien))
    {
       swiatlo_gora = analogRead(CZ_G); // zarejestrowanie aktualnego natężenia światła - czujnik górny
       swiatlo_dol = analogRead(CZ_D);  // zarejestrowanie aktualnego natężenia światła - czujnik dolny
       if ((swiatlo_gora < dzien_noc) and (swiatlo_dol < dzien_noc))  // jeśli natężenie śwaitła jest poza progiem noc/dzień
       {
         if (czas_1 == 0) czas_1 = millis();  // rozpoczęcie odliczania czasu
         if (millis() - czas_1 > czas_noc_dzien) dzien = true; // jeśli po upływie czasu zapisanego w zmiennej czas_noc_dzien
                                                                 // czujniki nadal będą odczytywały natężenie światłą poza progiem dzień/noc
                                                                 // nastapi zinterpretowanie tego faktu jako noc
       }
       else czas_1 = 0;       // jeśli natężenie śwaitła zarejestrowanego przez oba czujniki nie będzie poza
                              // progiem dzień/noc - nastapi wyzerowanie zmiennej czas_1
    }
}

// procedury

void pobudka()
{
  for(glowa_pozycja = 0; glowa_pozycja <=glowa_norm; glowa_pozycja += 5)
  {
    pwm_d1 = map(glowa_pozycja, 0, glowa_norm, 0, pwm_norm);
    pwm_d2 = pwm_d1;
    ton = map(glowa_pozycja, 0, glowa_norm, 100, 1200); // częstotliwość dźwieku będzie stopniowo rosła
    serwomechanizm.write(glowa_pozycja); //głowa będzie się unosiła stopniowo
    analogWrite(D1, pwm_d1); // diody będą się stopniowo rozjaśniać
    analogWrite(D2, pwm_d2);
    tone(GL, ton);
    delay(50);
  }
  noTone(GL); 
}

void zasypia()
{
  for(glowa_pozycja = glowa_norm; glowa_pozycja >=0; glowa_pozycja -= 10)
  {
    pwm_d1 = map(glowa_pozycja, 0, glowa_norm, 0, pwm_norm);
    pwm_d2 = pwm_d1;
    serwomechanizm.write(glowa_pozycja); //głowa będzie stopniowo opadała 
    analogWrite(D1, pwm_d1); // diody będą się stopniowo wygaszać
    analogWrite(D2, pwm_d2);
      //sekwencja generowanych dźwieków
      tone(GL, 100);
      delay(200);
      noTone(GL);
      delay(200);
      tone(GL, 80);
      delay(200);
      noTone(GL);
      delay(200);
      tone(GL, 60);
      delay(200);
      noTone(GL);
      delay(200);
      tone(GL, 40);
      delay(200);
      noTone(GL);
    }
}
void swiatlo_otoczenia()
{
  // natężenie śwaitła będzie odczytywane 10 razy w odstępach 20 ms
  // ostateczne natężenie tła będzie obliczone jako średnia z dziesięciu odczytów
  swiatlo_gora_tlo = 0;
  swiatlo_dol_tlo = 0;
  for(int i = 1; i<=10; i++)
  {
    swiatlo_gora_tlo = swiatlo_gora_tlo + analogRead(CZ_G);
    swiatlo_dol_tlo = swiatlo_dol_tlo + analogRead(CZ_D);
    delay(20);
  }
  swiatlo_gora_tlo = swiatlo_gora_tlo/10;
  swiatlo_dol_tlo = swiatlo_dol_tlo/10;
}
void reakcja_1()
{
  tone(GL,300);
  delay(200);
  noTone(GL);
  delay(50);
  tone(GL,600);
  delay(200);
  noTone(GL);
  delay(50);
  tone(GL,300);
  delay(200);
  noTone(GL);
  delay(50);
  tone(GL,1000);
  delay(200);
  noTone(GL);
 }
 void reakcja_2()
 {
    int losowy;
    for(int i =0; i<10; i++)
    {
      tone(GL,random(200,2000));
      for(pwm_d1=pwm_norm; pwm_d1<256; pwm_d1++)
      {
          pwm_d2=map(pwm_d1,pwm_norm,255,pwm_norm,0);
          analogWrite(D1, pwm_d1); 
          analogWrite(D2, pwm_d2);
          delayMicroseconds(50);      
      }
      tone(GL,random(200,2000));
      for(pwm_d2=pwm_norm; pwm_d2<256; pwm_d2++)
      {
          pwm_d1=map(pwm_d2,pwm_norm,255,pwm_norm,0);
          analogWrite(D1, pwm_d1); 
          analogWrite(D2, pwm_d2);
          delayMicroseconds(50);      
      }
    }
     analogWrite(D1, pwm_norm); 
     analogWrite(D2, pwm_norm);
     noTone(GL);
 }
 void reakcja_3()
 {
    for(glowa_pozycja=glowa_norm; glowa_pozycja<=180; glowa_pozycja += 30)
    {
      serwomechanizm.write(glowa_pozycja);
      ton = map(glowa_pozycja,glowa_norm,180,500,2000);
      tone(GL,ton);
      delay(100);
    }
    serwomechanizm.write(glowa_norm);
    reakcja_2();
 }
 void reakcja_4()
 {
  serwomechanizm.write(0); 
  for(int i=1; i<6; i++)
  {
    tone(GL,random(100,3000));
    delay(100);
  }
  noTone(GL);
  for(glowa_pozycja = 0; glowa_pozycja<150; glowa_pozycja += 50)
  {
     serwomechanizm.write(glowa_pozycja+30);
     for(pwm_d1=pwm_norm; pwm_d1<256; pwm_d1 += 30)
     {
        pwm_d2=pwm_d1;
        analogWrite(D1, pwm_d1); 
        analogWrite(D2, pwm_d2);  
        delay(30);
     }
     serwomechanizm.write(glowa_pozycja);
     for(pwm_d1=pwm_norm; pwm_d1<256; pwm_d1 += 30)
     {
        pwm_d2=pwm_d1;
        analogWrite(D1, pwm_d1); 
        analogWrite(D2, pwm_d2);  
        delay(30);
     }
  }
     analogWrite(D1, pwm_norm); 
     analogWrite(D2, pwm_norm);
     serwomechanizm.write(glowa_norm);
 }
 void reakcja_5()
 {
  for(int j=1; j<4; j++)
  {
     analogWrite(D1, 255); 
     analogWrite(D2, 255);
     for(int i=1; i<6; i++)
     {
       tone(GL,random(100,400));
       delay(100);
     }
     analogWrite(D1, 0); 
     analogWrite(D2, 0);
     for(int i=1; i<6; i++)
     {
       tone(GL,random(100,400));
       delay(100);
     }
  }
  noTone(GL);
  analogWrite(D1, pwm_norm); 
  analogWrite(D2, pwm_norm);
 }
